/************************************************************************
 *									*
 *		r^f@botvO				*
 *									*
 *				: PTTRaf[^M荞ݏ	*
 *		t@C	: intmbi_rx.c				*
 *									*
 ************************************************************************/

#pragma	SECTION	PROG=intmbi_rx

#include "sg_cpu.h"

/*	֐	*/
static	void	read_mbi(void);
/*static*/	void	filtering(void);

/*=======================================================================
 |
 |		PTTRaf[^M荞ݏ
 |
 |	void	intmbi_rx()
 |
 =======================================================================*/
#pragma	INTERRUPT
void	intmbi_rx()
{
	/* Mf[^̓ǂݍ */
	read_mbi();

	switch (sg_mode) {
	case MODE_AI:		/* `h\[h */
		/* tC^O */
		filtering();

		/* `h\pc^oZbg */
		dp_ai_pitch();		/* sb` */
		dp_ai_roll();		/* [ */
		dp_ai_mhdg();		/*  */
		dp_ai_tas();		/* ^Cx */
		dp_ai_alt();		/* Cx */
		dp_ai_rollscale();	/* [XP[ */
		break;
	case MODE_HUD:		/* gtc\[h */
		/* tC^O */
		filtering();

		/* gtc\pc^oZbg */
		dp_hud_pitch();		/* sb` */
		dp_hud_roll();		/* [ */
		dp_hud_ias();		/* wCx */
		dp_hud_mhdg();		/*  */
		dp_hud_alt();		/* Cx */
		dp_hud_vvc();		/* xVeB[xN^ */
		break;
	case MODE_HDD:		/* gcc\[h */
		/* tC^O */
		filtering();

		/* gcc\pc^oZbg */
		dp_hdd_tas();		/* ^Cx */
		dp_hdd_alt();		/* Cx */
		break;
	case MODE_MENU:		/* j[\[h */
		/* c^o͖ */
		break;
	case MODE_DATA:		/* OƓxf[^\[h */
		/* OƓxf[^\pc^oZbg */
		dp_gaikou();
		break;
	}
}
#pragma	INTERRUPT-

/*=======================================================================
 |
 |		PTTRaMf[^ǂݍݏ
 |
 |	void	read_mbi()
 |
 =======================================================================*/
static	void	read_mbi()
{
	short	read_counter;
	short	rqspp, rqtpp;
	short	word_count, i;
	word	*rbufp, *wbufp;

	read_counter = 0;	/* ǂݍ݃JE^NA */

	for (;;) {
		/* L[|C^`FbN */
		rqspp = *REG_MBI_RQSP & 0x0fff;
		rqtpp = *REG_MBI_RQTP & 0x0fff;
		if (rqspp == rqtpp)
			break;

		/* ǂݍ݃JE^`FbN */
		if (++read_counter >= 8)
			break;

		/* ubNԃ^C}[Zbg */
		tmc_1553B = 0;			/* ^C}[JE^NA */
		tmf_1553B = TIMER_START;	/* ^C}[N */
		tmo_1553B = 0;			/* ^CAEgtOZbg*/

		/* Mf[^ǂݍ */
		command_word = *(REG_MBI_RQMT + rqspp / 2);
		word_count = command_word & 0x1f;
		rbufp = REG_MBI_BMWB + rqspp * 32;
		if (word_count == 8) {		/* f[^ރ`FbN */
			/* sf[^ */
			wbufp = (word *)&orgdata;
			r1553B_data = 1;
		} else {
			/* OƓxf[^ */
			wbufp = (word *)&lumdata;
			r1553B_data = 2;
		}
		for (i = 0; i < word_count; i++) {
			*wbufp++ = *rbufp;	/* f[^ǂݍ */
			rbufp = (word *)((char *)rbufp + 1);
		}
	}
}

/*=======================================================================
 |
 |		tB^O
 |
 |	void	filtering()
 |
 =======================================================================*/
/*static*/	void	filtering()
{
	/* @̃sb` */
	tmpdata.IPTCHA += (((short)(orgdata.IPTCHA & 0xfff0) - tmpdata.IPTCHA) * (long)DELTA_t) / (T_IPTCHA + DELTA_t);
	fltdata.IPTCHA = tmpdata.IPTCHA >> 4;

	/* @̃[ */
	tmpdata.IROLLA += (((short)(orgdata.IROLLA & 0xfff0) - tmpdata.IROLLA) * (long)DELTA_t) / (T_IROLLA + DELTA_t);
	fltdata.IROLLA = tmpdata.IROLLA >> 4;

	/* wxVeBxN^ */
	tmpdata.OHVVCX += (((short)(orgdata.OHVVCX & 0xffc0) - tmpdata.OHVVCX) * (long)DELTA_t) / (T_OHVVCX + DELTA_t);
	fltdata.OHVVCX = tmpdata.OHVVCX >> 6;

	/* xxVeBxN^ */
	tmpdata.OHVVCY += (((short)(orgdata.OHVVCY & 0xffc0) - tmpdata.OHVVCY) * (long)DELTA_t) / (T_OHVVCY + DELTA_t);
	fltdata.OHVVCY = tmpdata.OHVVCY >> 6;

	/* @̎ */
	fltdata.IMAGHD = (ushort)orgdata.IMAGHD >> 4;

	/* Cx */
	if (orgdata.IHBALT != 0x8000)
		fltdata.IHBALT = orgdata.IHBALT + 31512; /* 31512 = 39390ft */

	/* ^Cx */
	if ((orgdata.IASPDT & BIT0) == 0)
		fltdata.IASPDT = orgdata.IASPDT >> 1;

	/* wCx */
	if ((orgdata.IASPDI & BIT0) == 0)
		fltdata.IASPDI = orgdata.IASPDI >> 1;
}
